

var closeTabsProgressListener =
{
  onStateChange:function(aProgress,aRequest,aFlag,aStatus)
  {
     try {
     	aRequest.QueryInterface(Components.interfaces.nsIChannel);
     } catch (e) {
	return;
     }
    
    aRequest.QueryInterface(Components.interfaces.nsIChannel);
    if(aFlag & STATE_STOP) {
      loadPage();
    }
  },
  
  onLocationChange:function(a,b,c){},
  onProgressChange:function(a,b,c,d,e,f){},
  onStatusChange:function(a,b,c,d){},
  onSecurityChange:function(a,b,c){},

  /*XXX
    This is not nsIWebProgressListenr method,
    just killing a error in tabbrowser.xml
    Maybe a bug.
  */
  onLinkIconAvailable:function(a){}
};


function closeTabs() {
  var tabbedBrowser = top.document.getElementById("content");
  tabbedBrowser.addProgressListener(closeTabsProgressListener, NOTIFY_STATE_DOCUMENT);
  tabbedBrowser.selectedTab = tabbedBrowser.addTab("chrome://samucayasidebar/content/samucayaCloseTabs.xul");
}


function loadPage() {
  var tabbedBrowser = top.document.getElementById("content");
  tabbedBrowser.removeProgressListener(closeTabsProgressListener, NOTIFY_STATE_DOCUMENT);
  var doc = content.document;
  var num = gBrowser.browsers.length;
  
  var vboxEle = doc.getElementById("closeTablsListBox");
  
  for (var i = 0; i < num; i++) {
    var b = gBrowser.getBrowserAtIndex(i);
   	
    try {
    	var checkbox = doc.createElement("checkbox");
	checkbox.setAttribute("label", b.currentURI.spec);
	checkbox.setAttribute("checked", "true");
	vboxEle.appendChild(checkbox);
    } catch(e) {
      Components.utils.reportError(e);
    }
  }
}


function removeTabs() {
  var vboxItem = document.getElementById("closeTablsListBox");
  var cn = vboxItem.childNodes;
  
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                     .getService(Components.interfaces.nsIWindowMediator);

  var browserWindow = wm.getMostRecentWindow("navigator:browser");
  
  for (var i = cn.length; i > 0; i--) {
    if (cn[i-1].getAttribute("checked") == "true" && browserWindow.gBrowser.getBrowserAtIndex(i-1).currentURI.spec == cn[i-1].getAttribute("label")) {
      browserWindow.gBrowser.mTabContainer.selectedIndex = i-1;
      var tab = browserWindow.gBrowser.mTabContainer.selectedItem;
      browserWindow.gBrowser.removeTab(tab);
    }
  }  
}
